import random
import pygame
from datetime import datetime
from time import time
import json
pygame.init()

#------------------------------------------------------------------------------------------------------------------------------------------------------------------------
# settings

WIDTH = 1600
HEIGHT = 900
ROW = 9
ROWS = 6
DISTANCE_X = 12
DISTANCE_Y = 7
SIZE_X = 165
SIZE_Y = 121
COORD_X = 9
COORD_Y = 9
TEXT_SIZE = 35
TEXT_COORD_X = 22
TEXT_COORD_Y = 28
MENU_BUTTON_SIZE_X = 215
MENU_BUTTON_SIZE_Y = 50
MENU_BUTTON_DISTANCE = 75
MENU_BUTTON_TEXT_SIZE = 30
LOGO_SIZE_X = 815
LOGO_SIZE_Y = 450
LOGO_TEXT_SIZE = 200

# text fonts
font_cards = pygame.font.SysFont("comicsansms", 35)
font_menu_logo = pygame.font.SysFont("comicsansms", 200)
font_menu = pygame.font.SysFont("timesnewroman", 30)
font_fps = pygame.font.SysFont("timesnewroman", 20)
font_info = pygame.font.SysFont("timesnewroman", 50)

# useful things
screen_size = ''
err = ''
card_count = 50

def start() -> str:
    global WIDTH, HEIGHT, ROW, ROWS, DISTANCE_X, DISTANCE_Y, SIZE_X, SIZE_Y, COORD_X, COORD_Y
    global TEXT_SIZE, TEXT_COORD_X, TEXT_COORD_Y, LOGO_SIZE_X, LOGO_SIZE_Y, LOGO_TEXT_SIZE
    global MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y, MENU_BUTTON_DISTANCE, MENU_BUTTON_TEXT_SIZE, screen_size, card_count
    global font_menu, font_menu_logo, font_fps, font_info, font_cards

    try:
        # importing saved screen size
        with open('data/settings.json', 'r') as file:
            d = json.load(file)
            screen_size = d['screen_size']
            card_count = d['card_count']

        # importing changeable settings
        with open(f'data/{screen_size}.json', 'r') as f:
            data = json.load(f)

            WIDTH = data['WIDTH']
            HEIGHT = data['HEIGHT']
            ROW = data['ROW']
            ROWS = data['ROWS']
            DISTANCE_X = data['DISTANCE_X']
            DISTANCE_Y = data['DISTANCE_Y']
            SIZE_X = data['SIZE_X']
            SIZE_Y = data['SIZE_Y']
            COORD_X = data['COORD_X']
            COORD_Y = data['COORD_Y']
            TEXT_SIZE = data['TEXT_SIZE']
            TEXT_COORD_X = data['TEXT_COORD_X']
            TEXT_COORD_Y = data['TEXT_COORD_Y']
            MENU_BUTTON_SIZE_X = data['MENU_BUTTON_SIZE_X']
            MENU_BUTTON_SIZE_Y = data['MENU_BUTTON_SIZE_Y']
            MENU_BUTTON_DISTANCE = data['MENU_BUTTON_DISTANCE']
            MENU_BUTTON_TEXT_SIZE = data['MENU_BUTTON_TEXT_SIZE']
            LOGO_SIZE_X = data['LOGO_SIZE_X']
            LOGO_SIZE_Y = data['LOGO_SIZE_Y']
            LOGO_TEXT_SIZE = data['LOGO_TEXT_SIZE']
    except FileNotFoundError:
        return 'Нет папки data с файлами игры!'

    # text fonts (they should be updated)
    font_cards = pygame.font.SysFont("comicsansms", TEXT_SIZE)
    font_menu_logo = pygame.font.SysFont("comicsansms", LOGO_TEXT_SIZE)
    font_menu = pygame.font.SysFont("timesnewroman", MENU_BUTTON_TEXT_SIZE)
    font_fps = pygame.font.SysFont("timesnewroman", 20)
    font_info = pygame.font.SysFont("timesnewroman", 50)

    return ''

# error check
temp = start()
if temp:
    err = temp

# window characteristics
pygame.display.set_caption('MEMO')
pygame.init()
screen = pygame.display.set_mode((WIDTH, HEIGHT))
clock = pygame.time.Clock()

# cards characteristics
color_card = (0, 125, 255)
color_opening_card = (0, 125, 255)

# click pause
click_pause = False
click_pause_menu = False
timer = 0.0

# additional game info
time_now = 0.0
timer_main = 0.0
move_counter = 0
win = False

# different lists and dictionary used in main cycle
images = []
cards_closed = []
cards_opened = []
check_dictionary = {}
head_side = []
del_card = []

# menus targets
running = True
start_menu_show = True
authors_menu_show = True
settings_menu_show = True
pause_menu_show = True
rules_menu_show = True


#------------------------------------------------------------------------------------------------------------------------------------------------------------------------
# functions

def card_create() -> str: # importing pictures and randomaze cards
    global images, cards_closed, cards_opened, check_dictionary, head_side, del_card, card_count
    # different lists and dictionary used in main cycle
    images = []
    cards_closed = []
    cards_opened = []
    check_dictionary = {}
    head_side = []
    del_card = []

    try:
        with open('cards/words.txt', 'r') as f: # importing pictures
            for line in f.readlines():
                line = list(line.split())

                # use all words
                name = ''
                for i in line:
                    if not i.isdigit():
                        name = name + i + ' '

                if not name:
                    return 'Не хватает слов!'

                try: # images count check
                    image_on_card = pygame.image.load(f'cards/{int(line[0])}.jpg')
                except FileNotFoundError:
                    try:
                        image_on_card = pygame.image.load(f'cards/{int(line[0])}.png')
                    except FileNotFoundError:
                        try:
                            image_on_card = pygame.image.load(f'cards/{int(line[0])}.jpeg')
                        except FileNotFoundError:
                            return 'Не хватает фотографий для карточек!'
                except IndexError:
                    return 'Не хватает слов!'

                image = pygame.transform.scale(image_on_card, (SIZE_X, SIZE_Y))
                images.append(image)

                # list with all card head sides
                head_side.append(int(line[0])-1) # (-1 for identity list index)
                head_side.append(name)

                check_dictionary[name] = int(line[0])-1 # description = number of picture(-1 for identity list index)

        if len(head_side) < card_count:
            return 'Не хватает слов!'

        random.shuffle(head_side) # randomize cards

    except FileNotFoundError:
        return 'Не хватает фотографий для карточек!'

    # create card coordinates list
    c = 0
    for k in range(ROWS):
        for i in range(ROW):
            cards_closed.append([COORD_X + (SIZE_X + DISTANCE_X) * i, COORD_Y + (SIZE_Y + DISTANCE_Y) * k, c]) # [x, y, index]
            c += 1
            if c == card_count: # cards count
                break
        if c == card_count:
            break

    return ''


# drawing button and checking clicks
def button(x: int, y: int, size_x_button: int, size_y_button: int, color_1: tuple, color_2: tuple,
           text_x: int, text_y: int, text_button: str, font, new_size: int = 10, border_radius: int = 10) -> bool:
    global click_pause_menu, click_pause
    checking = not (click_pause_menu or click_pause) # different types of click  pause

    # draw button
    pygame.draw.rect(screen, color_1, (x, y, size_x_button, size_y_button), (size_y_button+1)//2, border_radius)
    text_menu = font.render(text_button, True, (0, 0, 0))
    screen.blit(text_menu, (x + text_x, y + text_y))

    x_mouse, y_mouse = pygame.mouse.get_pos() # cursor coordinates
    mouse = pygame.mouse.get_pressed() # is mouse button pressed

    if checking: # click pause
        # cursor position check
        if x <= x_mouse <= x + size_x_button:
            if y <= y_mouse <= y + size_y_button:
                # draw button selection
                pygame.draw.rect(screen, color_2,
                                 (x - new_size//2, y - new_size//2, size_x_button + new_size, size_y_button + new_size),
                                 (size_y_button + new_size + 1) // 2, border_radius)
                text_menu = font.render(text_button, True, (0, 0, 0))
                screen.blit(text_menu, (x + text_x, y + text_y))

                if mouse[0]: # mouse[0] -> left mouse button
                    return True
    return False


#------------------------------------------------------------------------------------------------------------------------------------------------------------------------
# menus

def start_menu():
    global start_menu_show, settings_menu_show, authors_menu_show, rules_menu_show, running, time_now, click_pause_menu, timer, err, move_counter, win

    while start_menu_show:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                exit()

        # background
        screen.fill((100, 200, 255))
        pygame.draw.polygon(screen, (255, 127, 0), ((0, 100), (0, 400), (WIDTH, HEIGHT-100), (WIDTH, HEIGHT-400)))
        pygame.draw.rect(
            screen,
            (255, 255, 255),
            (MENU_BUTTON_DISTANCE // 2, HEIGHT - MENU_BUTTON_DISTANCE * 4 - MENU_BUTTON_DISTANCE // 2,
             MENU_BUTTON_SIZE_X + MENU_BUTTON_DISTANCE, MENU_BUTTON_DISTANCE * 5),
            MENU_BUTTON_SIZE_X,
            10
        )

        # logo
        pygame.draw.rect(screen, (255, 255, 255),
                         (WIDTH // 2 - LOGO_SIZE_X//2, HEIGHT // 2 - LOGO_SIZE_Y//2, LOGO_SIZE_X, LOGO_SIZE_Y),
                         LOGO_SIZE_X//2, 50)
        pygame.draw.rect(screen, (0, 125, 255),
                         (WIDTH // 2 - LOGO_SIZE_X//2 + 20, HEIGHT // 2 - LOGO_SIZE_Y//2 + 20, LOGO_SIZE_X-40, LOGO_SIZE_Y-40),
                         LOGO_SIZE_X//2, 50)
        text_menu = font_menu_logo.render('MEMO', True, (0, 0, 0))
        screen.blit(text_menu, (WIDTH // 2 - LOGO_TEXT_SIZE*1.6, HEIGHT // 2 - LOGO_TEXT_SIZE*0.7))

        # click pause
        if click_pause_menu:
            if timer >= 58 and int(datetime.now().strftime('%S')) - (timer - 60) or int(datetime.now().strftime('%S')) - timer >= 2:
                click_pause_menu = False

        # Error message
        if err:
            pygame.draw.rect(screen, (255, 000, 000), (WIDTH//2 - 470, HEIGHT//2 - 120, 940, 240), 300)
            pygame.draw.rect(screen, (255, 255, 255), (WIDTH//2 - 450, HEIGHT//2 - 100, 900, 200), 300)
            text_menu = font_info.render(err, True, (255, 0, 0))
            screen.blit(text_menu, (WIDTH//2-410, HEIGHT//2 - 35))

        # buttons
        if button(MENU_BUTTON_DISTANCE, HEIGHT - MENU_BUTTON_DISTANCE*4, MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 127, 0), (0, 255, 0), 55, 5, 'ИГРАТЬ', font_menu):
            timer = int(datetime.now().strftime('%S'))
            click_pause_menu = True
            move_counter = 0
            win = False

            a = card_create()
            if not a:
                time_now = time()
                start_menu_show = False
            else:
                err = a

        if button(MENU_BUTTON_DISTANCE, HEIGHT - MENU_BUTTON_DISTANCE*3, MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 127, 0), (0, 255, 0), 18, 5, 'НАСТРОЙКИ', font_menu):
            click_pause_menu = True
            timer = int(datetime.now().strftime('%S'))
            settings_menu_show = True
            settings_menu()

        if button(MENU_BUTTON_DISTANCE, HEIGHT - MENU_BUTTON_DISTANCE*2, MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 127, 0), (0, 255, 0), 45, 5, 'АВТОРЫ', font_menu):
            click_pause_menu = True
            timer = int(datetime.now().strftime('%S'))
            authors_menu_show = True
            authors_menu()

        if button(MENU_BUTTON_DISTANCE, HEIGHT - MENU_BUTTON_DISTANCE, MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 127, 0), (0, 255, 0), 50, 5, 'ВЫХОД', font_menu):
            exit()

        pygame.display.flip()
        clock.tick(60)


def authors_menu():
    global authors_menu_show, click_pause_menu, timer

    while authors_menu_show:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                exit()

        # background
        screen.fill((100, 200, 255))
        pygame.draw.polygon(screen, (255, 127, 0), ((0, 100), (0, 400), (WIDTH, HEIGHT-100), (WIDTH, HEIGHT-400)))
        pygame.draw.rect(
            screen,
            (255, 255, 255),
            (MENU_BUTTON_DISTANCE // 2, HEIGHT - MENU_BUTTON_DISTANCE * 4 - MENU_BUTTON_DISTANCE // 2,
             MENU_BUTTON_SIZE_X + MENU_BUTTON_DISTANCE, MENU_BUTTON_DISTANCE * 5),
            MENU_BUTTON_SIZE_X,
            10
        )

        pygame.draw.rect(screen, (255, 255, 255), (WIDTH // 2 - 300, HEIGHT // 2 - 200, 650, 400), 200, 10)

        # main part
        text_authors = 'Код: Попов Иван, 10б, 393 Лицей'
        text_authors = font_menu.render(text_authors, True, (0, 0, 0))
        screen.blit(text_authors, (WIDTH // 2 - 250, HEIGHT // 2 - 100))

        text_authors = 'Дизайн: Попов Иван, 10б, 393 Лицей'
        text_authors = font_menu.render(text_authors, True, (0, 0, 0))
        screen.blit(text_authors, (WIDTH // 2 - 250, HEIGHT // 2 - 10))

        text_authors = 'Звуки: в игре их нет)'
        text_authors = font_menu.render(text_authors, True, (0, 0, 0))
        screen.blit(text_authors, (WIDTH // 2 - 250, HEIGHT // 2 + 80))

        # click pause
        if click_pause_menu:
            if timer >= 58 and int(datetime.now().strftime('%S')) - (timer - 60) or int(datetime.now().strftime('%S')) - timer >= 2:
                click_pause_menu = False

        # button
        if button(MENU_BUTTON_DISTANCE, HEIGHT - MENU_BUTTON_DISTANCE*4, MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 127, 0), (0, 255, 0), 55, 5, 'НАЗАД', font_menu):
            click_pause_menu = True
            timer = int(datetime.now().strftime('%S'))
            authors_menu_show = False

        pygame.display.flip()
        clock.tick(60)


def pause_menu():
    global pause_menu_show, rules_menu_show, click_pause_menu, start_menu_show, timer, time_now, move_counter, win

    while pause_menu_show:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                exit()

        # background
        screen.fill((100, 200, 255))
        pygame.draw.polygon(screen, (255, 127, 0), ((0, 100), (0, 400), (WIDTH, HEIGHT-100), (WIDTH, HEIGHT-400)))
        pygame.draw.rect(
            screen,
            (255, 255, 255),
            (MENU_BUTTON_DISTANCE // 2, HEIGHT - MENU_BUTTON_DISTANCE * 4 - MENU_BUTTON_DISTANCE // 2,
             MENU_BUTTON_SIZE_X + MENU_BUTTON_DISTANCE, MENU_BUTTON_DISTANCE * 5),
            MENU_BUTTON_SIZE_X,
            10
        )

        # logo
        pygame.draw.rect(screen, (255, 255, 255),
                         (WIDTH // 2 - LOGO_SIZE_X//2, HEIGHT // 2 - LOGO_SIZE_Y//2, LOGO_SIZE_X, LOGO_SIZE_Y),
                         LOGO_SIZE_X//2, 50)
        pygame.draw.rect(screen, (0, 125, 255),
                         (WIDTH // 2 - LOGO_SIZE_X//2 + 20, HEIGHT // 2 - LOGO_SIZE_Y//2 + 20, LOGO_SIZE_X-40, LOGO_SIZE_Y-40),
                         LOGO_SIZE_X//2, 50)
        text_menu = font_menu_logo.render('MEMO', True, (0, 0, 0))
        screen.blit(text_menu, (WIDTH // 2 - LOGO_TEXT_SIZE*1.6, HEIGHT // 2 - LOGO_TEXT_SIZE*0.7))

        # click pause
        if click_pause_menu:
            if timer >= 58 and int(datetime.now().strftime('%S')) - (timer - 60) or int(datetime.now().strftime('%S')) - timer >= 2:
                click_pause_menu = False

        # buttons
        if button(MENU_BUTTON_DISTANCE, HEIGHT - MENU_BUTTON_DISTANCE*4, MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 127, 0), (0, 255, 0), 55, 5, 'НАЗАД', font_menu):
            click_pause_menu = True
            timer = int(datetime.now().strftime('%S'))
            pause_menu_show = False

        if button(MENU_BUTTON_DISTANCE, HEIGHT - MENU_BUTTON_DISTANCE*3, MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 127, 0), (0, 255, 0), 50, 5, 'ЗАНОВО', font_menu):
            time_now = time()
            timer = int(datetime.now().strftime('%S'))
            move_counter = 0
            pause_menu_show = False
            click_pause_menu = True
            win = False
            card_create()

        if button(MENU_BUTTON_DISTANCE, HEIGHT - MENU_BUTTON_DISTANCE*2, MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 127, 0), (0, 255, 0), 45, 5, 'ПРАВИЛА', font_menu):
            click_pause_menu = True
            timer = int(datetime.now().strftime('%S'))
            rules_menu_show = True
            rules_menu()

        if button(MENU_BUTTON_DISTANCE, HEIGHT - MENU_BUTTON_DISTANCE, MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 127, 0), (0, 255, 0), 60, 5, 'МЕНЮ', font_menu):
            click_pause_menu = True
            timer = int(datetime.now().strftime('%S'))
            pause_menu_show = False
            start_menu_show = True
            start_menu()

        pygame.display.flip()
        clock.tick(60)

def rules_menu():
    global rules_menu_show, click_pause_menu, timer

    while rules_menu_show:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                exit()

        # background
        screen.fill((100, 200, 255))
        pygame.draw.polygon(screen, (255, 127, 0), ((0, 100), (0, 400), (WIDTH, HEIGHT-100), (WIDTH, HEIGHT-400)))
        pygame.draw.rect(
            screen,
            (255, 255, 255),
            (MENU_BUTTON_DISTANCE // 2, HEIGHT - MENU_BUTTON_DISTANCE * 4 - MENU_BUTTON_DISTANCE // 2,
             MENU_BUTTON_SIZE_X + MENU_BUTTON_DISTANCE, MENU_BUTTON_DISTANCE * 5),
            MENU_BUTTON_SIZE_X,
            10
        )

        pygame.draw.rect(screen, (255, 255, 255), (WIDTH // 2 - 300, HEIGHT // 2 - 200, 650, 400), 200, 10)

        # main part
        text_rules = font_menu.render('Надо находить пары карт', True, (0, 0, 0))
        screen.blit(text_rules, (WIDTH // 2 - 250, HEIGHT // 2 - 100))

        text_rules = font_menu.render('по картинке и её переводу', True, (0, 0, 0))
        screen.blit(text_rules, (WIDTH // 2 - 250, HEIGHT // 2 - 50))

        # click pause
        if click_pause_menu:
            if timer >= 58 and int(datetime.now().strftime('%S')) - (timer - 60) or int(datetime.now().strftime('%S')) - timer >= 2:
                click_pause_menu = False

        # button
        if button(MENU_BUTTON_DISTANCE, HEIGHT - MENU_BUTTON_DISTANCE*4, MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 127, 0), (0, 255, 0), 55, 5, 'НАЗАД', font_menu):
            click_pause_menu = True
            timer = int(datetime.now().strftime('%S'))
            rules_menu_show = False

        pygame.display.flip()
        clock.tick(60)

def settings_menu():
    global settings_menu_show, click_pause_menu, screen_size, card_count, timer, screen, err

    while settings_menu_show:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                exit()

        # background
        screen.fill((100, 200, 255))
        pygame.draw.polygon(screen, (255, 127, 0),
                            ((0, 100), (0, 400), (WIDTH, HEIGHT - 100), (WIDTH, HEIGHT - 400)))
        pygame.draw.rect(
            screen,
            (255, 255, 255),
            (MENU_BUTTON_DISTANCE // 2, HEIGHT - MENU_BUTTON_DISTANCE * 4 - MENU_BUTTON_DISTANCE // 2,
             MENU_BUTTON_SIZE_X + MENU_BUTTON_DISTANCE, MENU_BUTTON_DISTANCE * 5),
            MENU_BUTTON_SIZE_X,
            10
        )

        pygame.draw.rect(screen, (255, 255, 255),
                         (WIDTH // 2 - MENU_BUTTON_SIZE_X*1.5, HEIGHT // 2 - MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_X*3, MENU_BUTTON_SIZE_X*2),
                         MENU_BUTTON_SIZE_X, 10)

        # screen size settings
        text_rules = font_menu.render('Разрешение', True, (0, 0, 0))
        screen.blit(text_rules, (WIDTH // 2 - MENU_BUTTON_SIZE_X*1.5 + 5, HEIGHT // 2 - MENU_BUTTON_SIZE_X))

        if button(WIDTH//2 - MENU_BUTTON_SIZE_X - MENU_BUTTON_DISTANCE//2, HEIGHT//2 - MENU_BUTTON_SIZE_X + MENU_BUTTON_DISTANCE,
                  MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 130, 0), (0, 255, 0), 45, 5, '1920x1080', font_menu):
            screen_size = '1920x1080'

        if button(WIDTH//2 + MENU_BUTTON_DISTANCE//2, HEIGHT//2 - MENU_BUTTON_SIZE_X + MENU_BUTTON_DISTANCE,
                  MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 130, 0), (0, 255, 0), 40, 5, '1600x900', font_menu):
            screen_size = '1600x900'

        if button(WIDTH//2 - MENU_BUTTON_SIZE_X - MENU_BUTTON_DISTANCE//2, HEIGHT//2 - MENU_BUTTON_SIZE_X + MENU_BUTTON_DISTANCE*2,
                  MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 130, 0), (0, 255, 0), 40, 5, '1366x768', font_menu):
            screen_size = '1366x768'

        if button(WIDTH//2 + MENU_BUTTON_DISTANCE//2, HEIGHT//2 - MENU_BUTTON_SIZE_X + MENU_BUTTON_DISTANCE*2, MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 130, 0), (0, 255, 0), 40, 5, '1280x720', font_menu):
            screen_size = '1280x720'

        # card count settings
        text_rules = font_menu.render('Количество карт', True, (0, 0, 0))
        screen.blit(text_rules, (WIDTH // 2 - MENU_BUTTON_SIZE_X * 1.5 + 5, HEIGHT // 2 - MENU_BUTTON_SIZE_X + MENU_BUTTON_DISTANCE * 3))

        pygame.draw.rect(screen, (205, 205, 205),
                         (WIDTH//2 - MENU_BUTTON_SIZE_X - MENU_BUTTON_DISTANCE//2, HEIGHT // 2 - MENU_BUTTON_SIZE_X + MENU_BUTTON_DISTANCE * 4,
                          MENU_BUTTON_SIZE_X, 30),
                         15, 2)

        text_rules = font_menu.render(f'{card_count}', True, (0, 0, 0))
        screen.blit(text_rules, (WIDTH//2 - MENU_BUTTON_SIZE_X - MENU_BUTTON_DISTANCE//2 + 5, HEIGHT // 2 - MENU_BUTTON_SIZE_X + MENU_BUTTON_DISTANCE * 4 - 2))

        if button(WIDTH//2 - 31 - MENU_BUTTON_DISTANCE//2, HEIGHT // 2 - MENU_BUTTON_SIZE_X + MENU_BUTTON_DISTANCE * 4,
                  31, 15,
                  (0, 130, 0), (0, 255, 0), 8, -5, '↑', font_menu, 0, 1):
            if card_count < 54:
                card_count += 2
                click_pause_menu = True
                timer = int(datetime.now().strftime('%S'))

        if button(WIDTH//2 - 31 - MENU_BUTTON_DISTANCE//2, HEIGHT // 2 - MENU_BUTTON_SIZE_X + MENU_BUTTON_DISTANCE * 4 + 15,
                  31, 15,
                  (0, 130, 0), (0, 255, 0), 8, -20, '↓', font_menu, 0, 1):
            if card_count > 2:
                card_count -= 2
                click_pause_menu = True
                timer = int(datetime.now().strftime('%S'))


        # click pause
        if click_pause_menu:
            if timer >= 59 and int(datetime.now().strftime('%S')) - (timer - 60) or int(
                    datetime.now().strftime('%S')) - timer >= 1:
                click_pause_menu = False

        # buttons
        if button(MENU_BUTTON_DISTANCE, HEIGHT - MENU_BUTTON_DISTANCE * 4, MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 127, 0), (0, 255, 0), 20, 5, 'СОХРАНИТЬ', font_menu):
            click_pause_menu = True
            timer = int(datetime.now().strftime('%S'))
            settings_menu_show = False

            # saving new settings
            with open('data/settings.json', 'r') as ff:
                sett = json.load(ff)
                sett['screen_size'] = screen_size
                sett['card_count'] = card_count

            with open('data/settings.json', 'r+') as ff:
                ff.truncate()
                json.dump(sett, ff)

            temp_settings = start()
            if temp_settings:
                err = temp_settings

            # opening new window
            screen = pygame.display.set_mode((WIDTH, HEIGHT))
            pygame.init()

        if button(MENU_BUTTON_DISTANCE, HEIGHT - MENU_BUTTON_DISTANCE * 3, MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
                  (0, 127, 0), (0, 255, 0), 55, 5, 'НАЗАД', font_menu):
            click_pause_menu = True
            timer = int(datetime.now().strftime('%S'))
            settings_menu_show = False

        pygame.display.flip()
        clock.tick(60)

#------------------------------------------------------------------------------------------------------------------------------------------------------------------------
# main cycle

start_menu()

while running:
    for event_main in pygame.event.get():
        if event_main.type == pygame.QUIT:
            exit()
        if event_main.type == pygame.KEYDOWN and event_main.key == pygame.K_F2:
            cards_closed = []
        if event_main.type == pygame.KEYDOWN and event_main.key == pygame.K_ESCAPE:
            exit()

    # background
    screen.fill((199, 252, 236))
    pygame.draw.rect(screen, (174, 183, 191), (0, HEIGHT - SIZE_Y, WIDTH, SIZE_Y), 800)


    # drawing cards
    for card in cards_closed:
        if button(card[0], card[1], SIZE_X, SIZE_Y, color_card, color_opening_card, TEXT_COORD_X, TEXT_COORD_Y, "MEMO", font_cards):
            del_card.append(card)

    # updating opened cards list
    for card in del_card:
        cards_opened.append(card)
        cards_closed.pop(cards_closed.index(card))
    else:
        del_card = []


    # card pair identity check
    if len(cards_opened) == 2 and not click_pause:
        main_a, main_b = head_side[cards_opened[0][2]], head_side[cards_opened[1][2]]

        if main_a in check_dictionary.keys():
            if check_dictionary[main_a] != main_b:
                cards_closed.append(cards_opened[0])
                cards_closed.append(cards_opened[1])
        elif main_b in check_dictionary.keys():
            if check_dictionary[main_b] != main_a:
                cards_closed.append(cards_opened[0])
                cards_closed.append(cards_opened[1])
        else:
            cards_closed.append(cards_opened[0])
            cards_closed.append(cards_opened[1])

        click_pause = True
        timer = int(datetime.now().strftime('%S'))
        move_counter += 1


    # click pause
    if click_pause:
        if timer >= 58 and int(datetime.now().strftime('%S')) - (timer - 60) or int(datetime.now().strftime('%S')) - timer >= 2:
            cards_opened = []
            click_pause = False

    if click_pause_menu:
        if timer >= 58 and int(datetime.now().strftime('%S')) - (timer - 60) or int(datetime.now().strftime('%S')) - timer >= 2:
            click_pause_menu = False


    # draw opened cards
    for data in cards_opened:
        pygame.draw.rect(screen, (255, 255, 255), (data[0], data[1], SIZE_X, SIZE_Y), SIZE_X // 2, 10)

        if type(head_side[data[2]]) == int:
            screen.blit(images[head_side[data[2]]], (data[0], data[1]))
        else:
            text = font_cards.render(head_side[data[2]], True, (0, 0, 0))
            screen.blit(text, (data[0] + 5, data[1] + SIZE_Y // 2 - 30))


    # bottom port
    if not win:
        a = time() - time_now
        timer_main = int(a)/100
        if timer_main % 1 >= 0.60:
            timer_main = timer_main + 1 - 0.6

    text_cards = font_info.render(f'Время: {timer_main:.2f}', True, (0, 0, 0))
    screen.blit(text_cards, (130, HEIGHT - SIZE_Y + SIZE_Y//3))

    text_cards = font_info.render(f'Ходы: {move_counter}', True, (0, 0, 0))
    screen.blit(text_cards, (430, HEIGHT - SIZE_Y + SIZE_Y//3))

    text_cards = font_fps.render(f'FPS: {int(clock.get_fps())}', True, (0, 0, 0))
    screen.blit(text_cards, (WIDTH-80, HEIGHT-20))

    if button(WIDTH-400, HEIGHT - SIZE_Y + SIZE_Y//3, MENU_BUTTON_SIZE_X, MENU_BUTTON_SIZE_Y,
              (0, 127, 0), (0, 255, 0), 55, 5, 'ПАУЗА', font_menu):
        click_pause_menu = True
        timer = int(datetime.now().strftime('%S'))
        pause_menu_show = True
        pause_menu()


    # win message
    if not cards_closed:
        text_cards = font_menu_logo.render('ПОБЕДА!', True,(0, 0, 0))
        screen.blit(text_cards, (WIDTH//5, HEIGHT//4))
        win = True


    pygame.display.flip()
    clock.tick(60)